{-# LINE 6 "deriving.lhs" #-}
{-#  LANGUAGE MultiParamTypeClasses         #-}
{-#  LANGUAGE DefaultSignatures             #-}
{-#  LANGUAGE FlexibleInstances             #-}
{-#  LANGUAGE FlexibleContexts              #-}
{-#  LANGUAGE KindSignatures                #-}
{-#  LANGUAGE EmptyDataDecls                #-}
{-#  LANGUAGE TypeOperators                 #-}
{-#  LANGUAGE TypeSynonymInstances          #-}
{-#  LANGUAGE ExistentialQuantification     #-}
{-#  LANGUAGE TypeFamilies                  #-}

module ThesisCodeDeriving where

  infixr 5 :+:
  infixr 6 :*:, ::*::
  infixr 7 :.:

  instance Empty Int where empty = 0

  type List = []
  data Bit = OBit | IBit
{-# LINE 20 "gp.lhs" #-}
  data Exp = Const Int | Plus Exp Exp deriving Show
{-# LINE 39 "gp.lhs" #-}
  test :: [Bit]
  test = encode (Plus (Const 1) (Const 2))
{-# LINE 76 "gp.lhs" #-}
  data U1            pT    =  U1_

  data (:+:)  fT gT  pT    =  L1_  { unL1  :: fT pT } |  R1_  { unR1  :: gT pT }

  data (:*:)  fT gT  pT    =  fT pT ::*:: gT pT
{-# LINE 90 "gp.lhs" #-}
  newtype Par1 pT         = Par1_ { unPar1 :: pT }
{-# LINE 99 "gp.lhs" #-}
  newtype Rec1   fT     pT    = Rec1_ { unRec1 :: fT pT }

  newtype (:.:)  fT gT  pT    = Comp1_ (fT (gT pT))
{-# LINE 108 "gp.lhs" #-}
  newtype K1 iT cT     pT  =  K1_  { unK1  :: cT }

  newtype M1 iT cT fT  pT  =  M1_  { unM1  :: fT pT }
{-# LINE 118 "gp.lhs" #-}
  data D0
  data C0
  data S0

  data R0
  data P0
{-# LINE 128 "gp.lhs" #-}
  type D1    = M1 D0
  type C1    = M1 C0
  type S1    = M1 S0

  type Rec0  = K1 R0
  type Par0  = K1 P0
{-# LINE 170 "gp.lhs" #-}
  class Datatype cT where
    datatypeName  :: tT cT (fT :: * -> *) pT -> String
    moduleName    :: tT cT (fT :: * -> *) pT -> String
  
  class Constructor cT where
    conName :: tT cT (fT :: * -> *) pT -> String

    conFixity :: tT cT (fT :: * -> *) pT -> Fixity
    conFixity = const Prefix

    conIsRecord :: tT cT (fT :: * -> *) pT -> Bool
    conIsRecord = const False
  
  class Selector cT where
    selName :: tT cT (fT :: * -> *) pT -> String
{-# LINE 195 "gp.lhs" #-}
  data Fixity = Prefix | Infix Associativity Int

  data Associativity = LeftAssociative | RightAssociative | NotAssociative
{-# LINE 231 "gp.lhs" #-}
  class Representable0 aT where
    type Rep0 aT :: * -> *

    from0  :: aT -> Rep0 aT xT
    to0    :: Rep0 aT xT -> aT
  
  class Representable1 fT where
    type Rep1 fT :: * -> *

    from1  :: fT pT -> Rep1 fT pT
    to1    :: Rep1 fT pT -> fT pT
{-# LINE 268 "gp.lhs" #-}
  data Exp_Datatype 
  data Const___Constructor  
  data Plus___Constructor  
  
  instance Datatype Exp_Datatype  where
    moduleName    _  = "ModuleName"
    datatypeName  _  = "Exp"
  
  instance Constructor Const___Constructor    where conName _ = "Const"
  instance Constructor Plus___Constructor     where conName _ = "Plus"
{-# LINE 287 "gp.lhs" #-}
  type Rep_0_Exp = D1 Exp_Datatype   (    C1 Const___Constructor    (Rec0 Int)
                                       :+:  C1 Plus___Constructor     (Rec0 Exp :*: Rec0 Exp))
{-# LINE 296 "gp.lhs" #-}
  instance Representable0 Exp where
    type Rep0 Exp = Rep_0_Exp

    from0 (Const n)    = M1_ (L1_ (M1_ (K1_ n)))
    from0 (Plus e e')  = M1_ (R1_ (M1_ (K1_ e ::*:: K1_ e')))
 
    to0 (M1_ (L1_ (M1_ (K1_ n))))               = Const n
    to0 (M1_ (R1_ (M1_ (K1_ e ::*:: K1_ e'))))  = Plus e e'
{-# LINE 314 "gp.lhs" #-}
  data List___Datatype 
  data Nil___Constructor  
  data Cons___Constructor  

  instance Datatype List___Datatype  where
    datatypeName  _  = "List"
    moduleName    _  = "List"

  instance Constructor Nil___Constructor    where
    conName _ = "Nil"
  instance Constructor Cons___Constructor   where
    conName _ = "Cons"
{-# LINE 329 "gp.lhs" #-}
  type Rep_0_List__ pT = D1 List___Datatype   (    C1 Nil___Constructor     U1
                                                :+:  C1 Cons___Constructor    (Par0 pT :*: Rec0 (List pT)))
  
  instance Representable0 (List pT) where
    type Rep0 (List pT) = Rep_0_List__ pT

    from0 []         = M1_ (L1_ (M1_ U1_))
    from0 (h : t)   = M1_ (R1_ (M1_ (K1_ h ::*:: K1_ t)))

    to0 (M1_ (L1_ (M1_ U1_)))                  = []
    to0 (M1_ (R1_ (M1_ (K1_ h ::*:: K1_ t))))  = h : t
{-# LINE 346 "gp.lhs" #-}
  type Rep_1_List__ = D1 List___Datatype   (    C1 Nil___Constructor     U1
                                             :+:  C1 Cons___Constructor    (Par1 :*: Rec1 []))
  
  instance Representable1 [] where
    type Rep1 [] = Rep_1_List__

    from1 []         = M1_ (L1_ (M1_ U1_))
    from1 (h : t)   = M1_ (R1_ (M1_ (Par1_ h ::*:: Rec1_ t)))

    to1 (M1_ (L1_ (M1_ U1_)))                      = []
    to1 (M1_ (R1_ (M1_ (Par1_ h ::*:: Rec1_ t))))  = h : t
{-# LINE 378 "gp.lhs" #-}
  infixr 6 :**:

  data Expr  pT  =  Const_ Int
                 |  Expr pT :**: Expr pT
                 |  EVar { unVar :: Var pT }
                 |  Let (List (Decl pT)) (Expr pT)

  data Decl  pT  =  Decl_ (Var pT) (Expr pT)

  data Var   pT  =  Var_ pT | VarL (Var (List pT))
{-# LINE 396 "gp.lhs" #-}
  data Times___Constructor  
  data EVar___Constructor  

  data UnVar_Selector 
  
  instance Constructor Times___Constructor   where
    conName      _ = ":*:"
    conFixity    _ = Infix RightAssociative 6

  instance Constructor EVar___Constructor   where
    conName      _ = "EVar"
    conIsRecord  _ = True

  instance Selector UnVar_Selector  where
    selName      _ = "unVar"
{-# LINE 416 "gp.lhs" #-}
  type Rep_1_Expr  =    D1 Expr_Datatype 
                       (         (  C1 Cnst___Constructor      (Rec0 Int)
                            :+:     C1 Times___Constructor     (Rec1 Expr :*: Rec1 Expr))
                       :+:       (  C1 EVar___Constructor      (S1 UnVar_Selector  (Rec1 Var))
                            :+:     C1 Let___Constructor       (([] :.: Rec1 Decl) :*: Rec1 Expr)))
{-# LINE 431 "gp.lhs" #-}
  data Expr_Datatype 
  data Var_Datatype 

  data Cnst___Constructor  
  data Let___Constructor  

  data Var___Constructor  
  data VarL___Constructor  
  
  type Rep_1_Decl  = Rec1 Var :*: Rec1 Expr
{-# LINE 446 "gp.lhs" #-}
  type Rep_1_Var   =  D1 Var_Datatype   (    C1 Var___Constructor     Par1 
                                          :+:  C1 VarL___Constructor    (Var :.: Rec1 []))
{-# LINE 455 "gp.lhs" #-}
  instance Representable1 Expr where
    type Rep1 Expr = Rep_1_Expr

    from1 (Const_ i)    = M1_ (L1_ (L1_ (M1_ (K1_ i))))
    from1 (e1 :**: e2)  = M1_ (L1_ (R1_ (M1_ (Rec1_ e1 ::*:: Rec1_ e2))))
    from1 (EVar v)      = M1_ (R1_ (L1_ (M1_ (M1_ (Rec1_ v)))))
    from1 (Let d e)     = M1_ (R1_ (R1_ (M1_ (Comp1_ (gmap Rec1_ d) ::*:: Rec1_ e))))

    to1 (M1_ (L1_ (L1_ (M1_ (K1_ i)))))                     = Const_ i
    to1 (M1_ (L1_ (R1_ (M1_ (Rec1_ e1 ::*:: Rec1_ e2)))))   = e1 :**: e2
    to1 (M1_ (R1_ (L1_ (M1_ (M1_ (Rec1_ v))))))             = EVar v
    to1 (M1_ (R1_ (R1_ (M1_ (Comp1_ d ::*:: Rec1_ e)))))    = Let (gmap unRec1 d) e
{-# LINE 478 "gp.lhs" #-}
  instance Representable1 Decl where
    type Rep1 Decl = Rep_1_Decl

    from1 (Decl_ v e)            = Rec1_ v ::*:: Rec1_ e

    to1 (Rec1_ v ::*:: Rec1_ e)  = Decl_ v e
{-# LINE 489 "gp.lhs" #-}
  instance Representable1 Var where
    type Rep1 Var = Rep_1_Var

    from1 (Var_ x)   = M1_ (L1_ (M1_ (Par1_ x)))
    from1 (VarL xs)  = M1_ (R1_ (M1_ (Comp1_ (gmap Rec1_ xs))))

    to1 (M1_ (L1_ (M1_ (Par1_ x))))    = Var_ x
    to1 (M1_ (R1_ (M1_ (Comp1_ xs))))  = VarL (gmap unRec1 xs)
{-# LINE 19 "functions.lhs" #-}
  class Encode' fT where
    encode' :: fT xT -> (List Bit)
{-# LINE 25 "functions.lhs" #-}
  instance Encode' U1 where
    encode' _ = []

  instance (Encode' fT) => Encode' (M1 iT cT fT) where
    encode' (M1_ a) = encode' a
{-# LINE 34 "functions.lhs" #-}
  instance  (Encode' fT, Encode' gT) => Encode' (fT  :+:  gT) where
    encode' (L1_  a)     =  OBit  : encode' a
    encode' (R1_  a)     =  IBit  : encode' a

  instance  (Encode' fT, Encode' gT) => Encode' (fT  :*:  gT) where
    encode' (a ::*:: b)  =  encode' a ++ encode' b
{-# LINE 44 "functions.lhs" #-}
  instance (Encode fT) => Encode' (K1 iT fT) where
    encode' (K1_ a) = encode a
{-# LINE 68 "functions.lhs" #-}
  instance Encode Int   where encode = undefined
  instance Encode Char  where encode = undefined
{-# LINE 82 "functions.lhs" #-}
  encode_Default :: (Representable0 aT, Encode' (Rep0 aT)) => aT -> (List Bit)
  encode_Default = encode' . from0
{-# LINE 106 "functions.lhs" #-}
  class Encode aT where
    encode :: aT -> (List Bit)

    default encode :: (Representable0 aT, Encode' (Rep0 aT)) => aT -> (List Bit)
    encode = encode' . from0
{-# LINE 119 "functions.lhs" #-}
  instance Encode Exp
{-# LINE 124 "functions.lhs" #-}
  instance (Encode aT) => Encode (List aT)
{-# LINE 146 "functions.lhs" #-}
  class GFunctor   fT where
    gmap   :: (pT -> aT) -> fT pT -> fT aT
    default gmap :: (Representable1 fT, GFunctor' (Rep1 fT)) => (pT -> aT) -> fT pT -> fT aT
    gmap f = to1 . gmap' f . from1

  class GFunctor'  fT where
    gmap'  :: (pT -> aT) -> fT pT -> fT aT
{-# LINE 164 "functions.lhs" #-}
  instance GFunctor' Par1 where
    gmap' f (Par1_ a) = Par1_ (f a)
{-# LINE 170 "functions.lhs" #-}
  instance GFunctor' U1 where
    gmap' f U1_          =  U1_

  instance GFunctor' (K1 iT cT) where
    gmap' f (K1_  a)     =  K1_  a

  instance (GFunctor' fT) => GFunctor' (M1 iT cT fT) where
    gmap' f (M1_  a)     =  M1_  (gmap' f a)

  instance  (GFunctor' fT, GFunctor' gT) => GFunctor' (fT :+: gT) where
    gmap' f (L1_  a)     =  L1_  (gmap' f a)
    gmap' f (R1_  a)     =  R1_  (gmap' f a)

  instance  (GFunctor' fT, GFunctor' gT) => GFunctor' (fT :*: gT) where
    gmap' f (a ::*:: b)  =  gmap' f a ::*:: gmap' f b
{-# LINE 189 "functions.lhs" #-}
  instance (GFunctor fT) => GFunctor' (Rec1 fT) where
    gmap' f (Rec1_ a) = Rec1_ (gmap f a)
{-# LINE 194 "functions.lhs" #-}
  instance  (GFunctor fT, GFunctor' gT) => GFunctor' (fT :.: gT) where
    gmap' f (Comp1_ x) = Comp1_ (gmap (gmap' f) x)
{-# LINE 215 "functions.lhs" #-}
  instance GFunctor []
{-# LINE 223 "functions.lhs" #-}
  instance GFunctor Expr

  instance GFunctor Decl

  instance GFunctor Var
{-# LINE 237 "functions.lhs" #-}
  class Empty aT where
    empty :: aT
{-# LINE 242 "functions.lhs" #-}
    default empty :: (Representable0 aT, Empty' (Rep0 aT)) => aT
    empty = to0 empty'
{-# LINE 252 "functions.lhs" #-}
  class Empty' fT where
    empty' :: fT xT
{-# LINE 257 "functions.lhs" #-}
  instance Empty' U1 where
    empty' = U1_

  instance (Empty' fT) => Empty' (M1 iT cT fT) where
    empty' = M1_ empty'

  instance (Empty' fT, Empty' gT) => Empty' (fT :*: gT) where
    empty' = empty' ::*:: empty'

  instance (Empty fT) => Empty' (K1 iT fT) where
    empty' = K1_ empty
{-# LINE 275 "functions.lhs" #-}
  instance (Empty' fT) => Empty' (fT :+: gT) where
    empty' = L1_ empty'
{-# LINE 297 "functions.lhs" #-}
  instance Empty Exp 

  instance (Empty pT) => Empty (List pT)
{-# LINE 308 "functions.lhs" #-}
  class GShow aT where 
    gshows  :: aT -> ShowS

    gshow   :: aT -> String
    gshow x = gshows x ""
{-# LINE 316 "functions.lhs" #-}
    default gshows :: (Representable0 aT, GShow' (Rep0 aT)) => aT -> ShowS
    gshows = gshows' False . from0
{-# LINE 325 "functions.lhs" #-}
  class GShow' fT where
    gshows' :: Bool -> fT xT -> ShowS
  
  instance (GShow' fT) => GShow' (D1 cT fT) where
    gshows'   b   (M1_ a)   = gshows' b a

  instance (GShow' fT, GShow' gT) => GShow' (fT :+: gT) where
    gshows'   b   (L1_  a)  = gshows' b a
    gshows'   b   (R1_  a)  = gshows' b a

  instance GShow' U1 where
    gshows'   _ U1_         = id

  instance (GShow fT) => GShow' (K1 iT fT) where
    gshows'   _   (K1_ a)   = gshows a
{-# LINE 349 "functions.lhs" #-}
  instance (GShow' fT, Constructor cT) => GShow' (C1 cT fT) where
    gshows' _ c@(M1_ a)  =  showString "(" . showString (conName c) 
                         .  showString " "
                         .  wrapR (gshows' (conIsRecord c) a . showString ")")

      where  wrapR :: ShowS -> ShowS
             wrapR s | conIsRecord c  = showString "{ " . s . showString " }"
             wrapR s | otherwise      =  s
{-# LINE 364 "functions.lhs" #-}
  instance (GShow' fT, Selector cT) => GShow' (S1 cT fT) where
    gshows' b s@(M1_ a)  
      | null (selName s)  =  gshows' b a
      | otherwise         =  showString (selName s)
                          .  showString " = " . gshows' b a

  instance (GShow' fT, GShow' gT) => GShow' (fT :*: gT) where
    gshows'  b (a ::*:: c)  =  gshows' b a 
                            .  showString (if b then "," else " ")
                            .  gshows' b c
{-# LINE 292 "compiler.lhs" #-}
  data NoSelector

  instance Selector NoSelector where
    selName _ = ""
{-# LINE 19 "conclusion.lhs" #-}
  class UHCRepresentable0 aT repT where
    uhcfrom0  :: aT -> repT xT
    uhcto0    :: repT xT -> aT
  
  class UHCRepresentable1 fT repT where
    uhcfrom1  :: fT pT -> repT pT
    uhcto1    :: repT pT -> fT pT
{-# LINE 35 "conclusion.lhs" #-}
  instance UHCRepresentable0 (List pT) (Rep_0_List__ pT) where

    uhcfrom0 []         = M1_ (L1_ (M1_ U1_))
    uhcfrom0 (h : t)   = M1_ (R1_ (M1_ (K1_ h ::*:: K1_ t)))

    uhcto0 (M1_ (L1_ (M1_ U1_)))                  = []
    uhcto0 (M1_ (R1_ (M1_ (K1_ h ::*:: K1_ t))))  = h : t
  
  instance UHCRepresentable1 [] Rep_1_List__ where

    uhcfrom1 []         = M1_ (L1_ (M1_ U1_))
    uhcfrom1 (h : t)   = M1_ (R1_ (M1_ (Par1_ h ::*:: Rec1_ t)))

    uhcto1 (M1_ (L1_ (M1_ U1_)))                      = []
    uhcto1 (M1_ (R1_ (M1_ (Par1_ h ::*:: Rec1_ t))))  = h : t
{-# LINE 264 "conclusion.lhs" #-}
  instance GShow Int where gshows = shows
{-# LINE 286 "conclusion.lhs" #-}
  data Perfect pT = Node pT | Perfect_ (Perfect (pT , pT))
{-# LINE 300 "conclusion.lhs" #-}
  data Pair pT = Pair_ pT pT
